*
*     QCD O(alpha_s^3) leading correction to \rho
*     
      complex*16 function drho_at1_as3 (alpha,alphas,mz,mw,mh,mtp)
      implicit none!
      real*8 ctw2,stw2,nf,gfermi,xt,lzt
      real*8 alpha,alphas,mz,mw,mh,mtp
      real*8 c1,c2,c3,c4,c5,c6,c7,c8,c9,c10
      real*8 nc,ca,cf,nl,tf
      include "constants.h"

      nf = 6
      ctw2 = mw**2/mz**2
      stw2 = 1-ctw2
      gfermi = pi*alpha/sqrt(2d0)/stw2/mw**2
      xt = sqrt(2d0)*gfermi*mtp**2/16/pi**2

*     Y. Schoeder et al., hep-ph/0504055
*     \delta^(3)_QCD singlet OS: Eq.(17), p.6
      c1 = 256d0/9
      c2 = -11792d0/3
      c3 = 20816d0/3
      c4 = -2624d0/9
      c5 = 5248d0/3
      c6 = -20992d0/3

      drho_at1_as3 =
     & +1d0/(4*pi)**3*(
     &     c1 + c2*z3 + c3*z4 + c4*ln2**4 + c5*z2*ln2**2 + c6*a4
     &                )
*     drho_at_as2 = 7.9326/pi^3 = 0.255838522 ! paper number
*     drho_at_as2 =               0.255838646 ! in real life
*     print *, drho_at_as3

c$$$      c1 = 1.521138276d0
c$$$      c2 = 1.236336499d0
c$$$      c3 = -4.596159345d0
c$$$      c4 = -2.313187377d0
c$$$      c5 = 0.7437683464d0
c$$$      c6 = 2.503654176d0
c$$$      c7 = -1.370511922d0
c$$$      c8 = 0.6880486468d0
c$$$      c9 = 0.8495320699d0
c$$$      c10 = 0.4681052884d0

      c1 = -0.78d0
      c2 = 17.20d0
      c3 = -0.43d0
      c4 = -8.74d0
      c5 = -30.95d0
      c6 = -0.54d0
      c7 = 24.82d0
      c8 = 0.30d0
      c9 = 0.71d0
      c10 = -3.44d0

      nc = 3
      ca = nc
      cf = (nc**2-1)/(2*nc)
      nl = 5
      tf = 1d0/2
      
      drho_at1_as3 = drho_at1_as3 +
     &     1d0/pi**3*(
     &      + c1*cf**2 + c2*cf**2*ca + (c3 + c4*nl)*cf**2*tf
     &     + c5*cf*ca**2 + (c6 + c7*nl)*cf*ca*tf
     &     + (c8 + c9*nl + c10*nl**2)*cf*tf**2
     &                )

      drho_at1_as3 = 3*xt*alphas**3*drho_at1_as3

c$$$      print *, (-93.15d0)*3*xt*(alphas/pi)**3
      
      return
      end
