#ifndef GENERAL_H
#define GENERAL_H

#include <iostream>
#include <string>
#include <cmath>
#include <limits>
#include <sys/stat.h>

namespace SANC {

inline double pow2(double x) {return x*x;}
const double M_NAN = std::numeric_limits<double>::quiet_NaN();
const double M_EPS = std::numeric_limits<double>::epsilon();
const double M_INF = std::numeric_limits<double>::infinity();

inline bool file_exists(const std::string& name) {
  struct stat buffer;
  return (stat(name.c_str(), &buffer) == 0);
}

}


#endif // GENERAL_H
