#ifndef INTEGRAND_H
#define INTEGRAND_H

#include "TFoamIntegrand.h"

namespace SANC {

class Info;
class LHEF;
class Process;

class Integrand: public TFoamIntegrand {
  public:
    Integrand(SANC::Info & _info, SANC::Process & _proc, int t=0);
    ~Integrand(void){}
    double Density(int ndim, double *Xarg);
    double Born(int ndim, double *Xarg);
    double Virt(int ndim, double *Xarg);
    double Hard(int ndim, double *Xarg);
    double Loop(int ndim, double *Xarg);
private:
  SANC::Info & info;
  SANC::Process & proc;
  int    m_Type; // Type of function
  double Mf1,Mf2,Mf3,Mf4,Mf1_2,Mf2_2,Mf3_2,Mf4_2;
  double sm,dm;
////////////////////////////////////////////////////////////////////////////
};

}
#endif
