************************************************************************
* sanc_nc_v2.00 package.
************************************************************************
* File (nc_br_12_12__16_16.f) is created on Сб янв 27 22:51:07 MSK 2018.
************************************************************************
* This is the FORTRAN module (nc_br_12_12__16_16) to calculate EW Born
* cross section and soft photon Bremsstrahlung
* for the el^- + el^- -> mo^- + mo^- process.
*
* It is produced by s2n package of SANC (v1.10) Project.
* Copyright (C), SANC Project Team, 2002-2018.
*
* http://sanc.jinr.ru/
* E-mail: <sanc@jinr.ru>
************************************************************************
      subroutine nc_br_12_12__16_16 (qs,ts,us,born,soft,hard)
      implicit none!
      include 's2n_declare.h'

      integer iborn_
      real*8 lnlaom
      real*8 softisr,softfsr,softifi
      real*8 betasmomo,ibetasmomo
      real*8 jintqsmomo

      soft = 0d0
      hard = 0d0

      cmz2 = mz2

      s = -qs
      t = -ts
      u = -us

      betasmomo = sqrt(1d0-4d0*mmo**2/s)
      ibetasmomo = 1d0/betasmomo

      iborn_ = iborn
      iborn  = 1
      call nc_si_12_12__16_16 (s,t,u,born)
      iborn  = iborn_
      if (born.ne.born) print *,'Born NAN!!!',s,t,u

      if (iborn.eq.1) return

      lnlaom = log(4d0*omega**2/tlmu2)
      jintqsmomo = log((1d0-betasmomo)/(1d0+betasmomo))

      softisr=
     & +born*pi*alpha*qel**2*(-1d0/3)
     & +lnlaom*born/pi*alpha*qel**2*(-1)
     & +lnlaom*log(-1d0/qs*mel**2)*born/pi*alpha*qel**2*(-1)
     & +log(-1d0/qs*mel**2)*born/pi*alpha*qel**2*(-1)
     & +log(-1d0/qs*mel**2)**2*born/pi*alpha*qel**2*(-1d0/2)

      softfsr=
     & +ibetasmomo*born/pi*alpha*qmo**2*(-jintqsmomo-1d0/2*jintqsmomo**2
     & +jintqsmomo**2*mmo**2/s)
     & +ibetasmomo*born*pi*alpha*qmo**2*(-1d0/3+2d0/3*mmo**2/s)
     & +ibetasmomo*lnlaom*born/pi*alpha*qmo**2*(-jintqsmomo+2*jintqsmomo
     & *mmo**2/s)
     & +ibetasmomo*log(2-2/(1+betasmomo))*born/pi*alpha*qmo**2*(2*jintqs
     & momo-4*jintqsmomo*mmo**2/s)
     & +ibetasmomo*ddilog(-1+2/(1+betasmomo))*born/pi*alpha*qmo**2*(2-4*
     & mmo**2/s)
     & +lnlaom*born/pi*alpha*qmo**2*(-1)

      softifi=
     & +lnlaom*log(1/(mmo**2+us)*mmo**2+1/(mmo**2+us)*ts)*born/pi*alpha*
     & qel*qmo*(2)
     & +log(1+1d0/qs/ts*(mmo**2-mel**2)**2+2/qs*mmo**2+1d0/qs*ts)*log(-1/(mmo**4+2*t
     & s*mmo**2+ts**2)*qs*ts)*born/pi*alpha*qel*qmo*(2)
     & +log(1+1d0/qs/us*(mmo**2-mel**2)**2+2/qs*mmo**2+1d0/qs*us)*log(-1/(mmo**4+2*u
     & s*mmo**2+us**2)*qs*us)*born/pi*alpha*qel*qmo*(-2)
     & +log(1-2/(1+betasmomo)/(mel**2+mmo**2+us)*mmo**2)*born/pi*alpha*qel*qmo*
     & (-2*jintqsmomo)
     & +log(1-2/(1+betasmomo)/(mel**2+mmo**2+us)*mmo**2)**2*born/pi*alpha*qel*q
     & mo*(1)
     & +log(1-2/(1+betasmomo)/(mel**2+mmo**2+ts)*mmo**2)*born/pi*alpha*qel*qmo*
     & (2*jintqsmomo)
     & +log(1-2/(1+betasmomo)/(mel**2+mmo**2+ts)*mmo**2)**2*born/pi*alpha*qel*q
     & mo*(-1)
     & +log(-1/(mmo**4+2*us*mmo**2+us**2)*qs*us)**2*born/pi*alpha*qel*qm
     & o*(-1)
     & +log(-1/(mmo**4+2*ts*mmo**2+ts**2)*qs*ts)**2*born/pi*alpha*qel*qm
     & o*(1)
     & +ddilog(1-2/(1+betasmomo)/(mel**2+mmo**2+us)*us)*born/pi*alpha*qel*qmo*(
     & -2)
     & +ddilog(1-2/(1+betasmomo)/(mel**2+mmo**2+ts)*ts)*born/pi*alpha*qel*qmo*(
     & 2)
     & +ddilog(-1d0/qs/ts*(mmo**2-mel**2)**2-2/qs*mmo**2-1d0/qs*ts)*born/pi*alpha*qe
     & l*qmo*(-2)
     & +ddilog(-1d0/qs/us*(mmo**2-mel**2)**2-2/qs*mmo**2-1d0/qs*us)*born/pi*alpha*qe
     & l*qmo*(2)
     & +ddilog(-1/(-mmo**2+us+betasmomo*mmo**2+betasmomo*us)*mmo**2-1/(-
     & mmo**2+us+betasmomo*mmo**2+betasmomo*us)*us+1/(-mmo**2+us+betasmo
     & mo*mmo**2+betasmomo*us)*betasmomo*mmo**2+1/(-mmo**2+us+betasmomo*
     & mmo**2+betasmomo*us)*betasmomo*us)*born/pi*alpha*qel*qmo*(2)
     & +ddilog(-1/(-mmo**2+ts+betasmomo*mmo**2+betasmomo*ts)*mmo**2-1/(-
     & mmo**2+ts+betasmomo*mmo**2+betasmomo*ts)*ts+1/(-mmo**2+ts+betasmo
     & mo*mmo**2+betasmomo*ts)*betasmomo*mmo**2+1/(-mmo**2+ts+betasmomo*
     & mmo**2+betasmomo*ts)*betasmomo*ts)*born/pi*alpha*qel*qmo*(-2)

      if (iqed.eq.1) then
         soft = softisr+softfsr+softifi
      elseif(iqed.eq.2) then
         soft = softisr
      elseif(iqed.eq.3) then
         soft = softifi
      elseif(iqed.eq.4) then
         soft = softfsr
      elseif(iqed.eq.5) then
         soft = softifi+softfsr
      elseif(iqed.eq.6) then
         soft = softisr+softifi
      endif
      soft = soft*cfprime
      if (soft.ne.soft) then
         print *,'Soft NAN!!!',s,t,u,born,softisr,softfsr,softifi
         print *,lnlaom*log(1/(mmo**2+us)*mmo**2+1/(mmo**2+us)*ts)*born/pi*alpha*qel*qmo*(2)
         print *,log(1+1d0/qs/ts*(mmo**2-mel**2)**2+2/qs*mmo**2+1d0/qs*ts)*log(-1/(mmo**4+2*ts*mmo**2+ts**2)*qs*ts)*born/pi*alpha*qel*qmo*(2)
         print *,log(1+1d0/qs/us*(mmo**2-mel**2)**2+2/qs*mmo**2+1d0/qs*us)*log(-1/(mmo**4+2*us*mmo**2+us**2)*qs*us)*born/pi*alpha*qel*qmo*(-2)
         print *,1+1/qs/us*(mmo**2-mel**2)**2+2/qs*mmo**2+1/qs*us
         print *,1+1/qs/us*mmo**4+2/qs*mmo**2+1/qs*us
         print *,mmo**4
         print *,qs*us
         print *,log(1-2/(1+betasmomo)/(mel**2+mmo**2+us)*mmo**2)*born/pi*alpha*qel*qmo*(-2*jintqsmomo)
         print *,log(1-2/(1+betasmomo)/(mel**2+mmo**2+us)*mmo**2)**2*born/pi*alpha*qel*qmo*(1)
         print *,log(1-2/(1+betasmomo)/(mel**2+mmo**2+ts)*mmo**2)*born/pi*alpha*qel*qmo*(2*jintqsmomo)
         print *,log(1-2/(1+betasmomo)/(mel**2+mmo**2+ts)*mmo**2)**2*born/pi*alpha*qel*qmo*(-1)
         print *,log(-1/(mmo**4+2*us*mmo**2+us**2)*qs*us)**2*born/pi*alpha*qel*qmo*(-1)
         print *,log(-1/(mmo**4+2*ts*mmo**2+ts**2)*qs*ts)**2*born/pi*alpha*qel*qmo*(1)
         print *,ddilog(1-2/(1+betasmomo)/(mel**2+mmo**2+us)*us)*born/pi*alpha*qel*qmo*(-2)
         print *,ddilog(1-2/(1+betasmomo)/(mel**2+mmo**2+ts)*ts)*born/pi*alpha*qel*qmo*(2)
         print *,ddilog(-1d0/qs/ts*(mmo**2-mel**2)**2-2/qs*mmo**2-1d0/qs*ts)*born/pi*alpha*qel*qmo*(-2)
         print *,ddilog(-1d0/qs/us*(mmo**2-mel**2)**2-2/qs*mmo**2-1d0/qs*us)*born/pi*alpha*qel*qmo*(2)
         print *,ddilog(-1/(-mmo**2+us+betasmomo*mmo**2+betasmomo*us)*mmo**2-1/(-mmo**2+us+betasmomo*mmo**2+betasmomo*us)*us+1/(-mmo**2+us+betasmo
     & mo*mmo**2+betasmomo*us)*betasmomo*mmo**2+1/(-mmo**2+us+betasmomo*mmo**2+betasmomo*us)*betasmomo*us)*born/pi*alpha*qel*qmo*(2)
         print *,ddilog(-1/(-mmo**2+ts+betasmomo*mmo**2+betasmomo*ts)*mmo**2-1/(-mmo**2+ts+betasmomo*mmo**2+betasmomo*ts)*ts+1/(-mmo**2+ts+betasmo
     & mo*mmo**2+betasmomo*ts)*betasmomo*mmo**2+1/(-mmo**2+ts+betasmomo*mmo**2+betasmomo*ts)*betasmomo*ts)*born/pi*alpha*qel*qmo*(-2)
      endif
      return
      end
