************************************************************************
* sanc_nc_v2.00 package.
************************************************************************
* File (nc_br_12_12__20_20.f) is created on Сб янв 27 22:51:07 MSK 2018.
************************************************************************
* This is the FORTRAN module (nc_br_12_12__20_20) to calculate EW Born
* cross section and soft photon Bremsstrahlung
* for the el^- + el^- -> ta^- + ta^- process.
*
* It is produced by s2n package of SANC (v1.10) Project.
* Copyright (C), SANC Project Team, 2002-2018.
*
* http://sanc.jinr.ru/
* E-mail: <sanc@jinr.ru>
************************************************************************
      subroutine nc_br_12_12__20_20 (qs,ts,us,born,soft,hard)
      implicit none!
      include 's2n_declare.h'

      integer iborn_
      real*8 lnlaom
      real*8 softisr,softfsr,softifi
      real*8 betastata,ibetastata
      real*8 jintqstata

      soft = 0d0
      hard = 0d0

      cmz2 = mz2

      s = -qs
      t = -ts
      u = -us

      betastata = sqrt(1d0-4d0*mta**2/s)
      ibetastata = 1d0/betastata

      iborn_ = iborn
      iborn  = 1
      call nc_si_12_12__20_20 (s,t,u,born)
      iborn  = iborn_
      if (born.ne.born) print *,'Born NAN!!!',s,t,u

      if (iborn.eq.1) return

      lnlaom = log(4d0*omega**2/tlmu2)
      jintqstata = log((1d0-betastata)/(1d0+betastata))

      softisr=
     & +born*pi*alpha*qel**2*(-1d0/3)
     & +lnlaom*born/pi*alpha*qel**2*(-1)
     & +lnlaom*log(-1d0/qs*mel**2)*born/pi*alpha*qel**2*(-1)
     & +log(-1d0/qs*mel**2)*born/pi*alpha*qel**2*(-1)
     & +log(-1d0/qs*mel**2)**2*born/pi*alpha*qel**2*(-1d0/2)

      softfsr=
     & +ibetastata*born/pi*alpha*qta**2*(-jintqstata-1d0/2*jintqstata**2
     & +jintqstata**2*mta**2/s)
     & +ibetastata*born*pi*alpha*qta**2*(-1d0/3+2d0/3*mta**2/s)
     & +ibetastata*lnlaom*born/pi*alpha*qta**2*(-jintqstata+2*jintqstata
     & *mta**2/s)
     & +ibetastata*log(2-2/(1+betastata))*born/pi*alpha*qta**2*(2*jintqs
     & tata-4*jintqstata*mta**2/s)
     & +ibetastata*ddilog(-1+2/(1+betastata))*born/pi*alpha*qta**2*(2-4*
     & mta**2/s)
     & +lnlaom*born/pi*alpha*qta**2*(-1)

      softifi=
     & +lnlaom*log(1/(mta**2+us)*mta**2+1/(mta**2+us)*ts)*born/pi*alpha*
     & qel*qta*(2)
     & +log(1+1d0/qs/ts*(mta**2-mel**2)**2+2/qs*mta**2+1d0/qs*ts)*log(-1/(mta**4+2*t
     & s*mta**2+ts**2)*qs*ts)*born/pi*alpha*qel*qta*(2)
     & +log(1+1d0/qs/us*(mta**2-mel**2)**2+2/qs*mta**2+1d0/qs*us)*log(-1/(mta**4+2*u
     & s*mta**2+us**2)*qs*us)*born/pi*alpha*qel*qta*(-2)
     & +log(1-2/(1+betastata)/(mel**2+mta**2+us)*mta**2)*born/pi*alpha*qel*qta*
     & (-2*jintqstata)
     & +log(1-2/(1+betastata)/(mel**2+mta**2+us)*mta**2)**2*born/pi*alpha*qel*q
     & ta*(1)
     & +log(1-2/(1+betastata)/(mel**2+mta**2+ts)*mta**2)*born/pi*alpha*qel*qta*
     & (2*jintqstata)
     & +log(1-2/(1+betastata)/(mel**2+mta**2+ts)*mta**2)**2*born/pi*alpha*qel*q
     & ta*(-1)
     & +log(-1/(mta**4+2*us*mta**2+us**2)*qs*us)**2*born/pi*alpha*qel*qm
     & o*(-1)
     & +log(-1/(mta**4+2*ts*mta**2+ts**2)*qs*ts)**2*born/pi*alpha*qel*qm
     & o*(1)
     & +ddilog(1-2/(1+betastata)/(mel**2+mta**2+us)*us)*born/pi*alpha*qel*qta*(
     & -2)
     & +ddilog(1-2/(1+betastata)/(mel**2+mta**2+ts)*ts)*born/pi*alpha*qel*qta*(
     & 2)
     & +ddilog(-1d0/qs/ts*(mta**2-mel**2)**2-2/qs*mta**2-1d0/qs*ts)*born/pi*alpha*qe
     & l*qta*(-2)
     & +ddilog(-1d0/qs/us*(mta**2-mel**2)**2-2/qs*mta**2-1d0/qs*us)*born/pi*alpha*qe
     & l*qta*(2)
     & +ddilog(-1/(-mta**2+us+betastata*mta**2+betastata*us)*mta**2-1/(-
     & mta**2+us+betastata*mta**2+betastata*us)*us+1/(-mta**2+us+betasta
     & ta*mta**2+betastata*us)*betastata*mta**2+1/(-mta**2+us+betastata*
     & mta**2+betastata*us)*betastata*us)*born/pi*alpha*qel*qta*(2)
     & +ddilog(-1/(-mta**2+ts+betastata*mta**2+betastata*ts)*mta**2-1/(-
     & mta**2+ts+betastata*mta**2+betastata*ts)*ts+1/(-mta**2+ts+betasta
     & ta*mta**2+betastata*ts)*betastata*mta**2+1/(-mta**2+ts+betastata*
     & mta**2+betastata*ts)*betastata*ts)*born/pi*alpha*qel*qta*(-2)

      if (iqed.eq.1) then
         soft = softisr+softfsr+softifi
      elseif(iqed.eq.2) then
         soft = softisr
      elseif(iqed.eq.3) then
         soft = softifi
      elseif(iqed.eq.4) then
         soft = softfsr
      elseif(iqed.eq.5) then
         soft = softifi+softfsr
      elseif(iqed.eq.6) then
         soft = softisr+softifi
      endif
      soft = soft*cfprime
      if (soft.ne.soft) then
         print *,'Soft NAN!!!',s,t,u,born,softisr,softfsr,softifi
         print *,lnlaom*log(1/(mta**2+us)*mta**2+1/(mta**2+us)*ts)*born/pi*alpha*qel*qta*(2)
         print *,log(1+1d0/qs/ts*(mta**2-mel**2)**2+2/qs*mta**2+1d0/qs*ts)*log(-1/(mta**4+2*ts*mta**2+ts**2)*qs*ts)*born/pi*alpha*qel*qta*(2)
         print *,log(1+1d0/qs/us*(mta**2-mel**2)**2+2/qs*mta**2+1d0/qs*us)*log(-1/(mta**4+2*us*mta**2+us**2)*qs*us)*born/pi*alpha*qel*qta*(-2)
         print *,1+1/qs/us*(mta**2-mel**2)**2+2/qs*mta**2+1/qs*us
         print *,1+1/qs/us*mta**4+2/qs*mta**2+1/qs*us
         print *,mta**4
         print *,qs*us
         print *,log(1-2/(1+betastata)/(mel**2+mta**2+us)*mta**2)*born/pi*alpha*qel*qta*(-2*jintqstata)
         print *,log(1-2/(1+betastata)/(mel**2+mta**2+us)*mta**2)**2*born/pi*alpha*qel*qta*(1)
         print *,log(1-2/(1+betastata)/(mel**2+mta**2+ts)*mta**2)*born/pi*alpha*qel*qta*(2*jintqstata)
         print *,log(1-2/(1+betastata)/(mel**2+mta**2+ts)*mta**2)**2*born/pi*alpha*qel*qta*(-1)
         print *,log(-1/(mta**4+2*us*mta**2+us**2)*qs*us)**2*born/pi*alpha*qel*qta*(-1)
         print *,log(-1/(mta**4+2*ts*mta**2+ts**2)*qs*ts)**2*born/pi*alpha*qel*qta*(1)
         print *,ddilog(1-2/(1+betastata)/(mel**2+mta**2+us)*us)*born/pi*alpha*qel*qta*(-2)
         print *,ddilog(1-2/(1+betastata)/(mel**2+mta**2+ts)*ts)*born/pi*alpha*qel*qta*(2)
         print *,ddilog(-1d0/qs/ts*(mta**2-mel**2)**2-2/qs*mta**2-1d0/qs*ts)*born/pi*alpha*qel*qta*(-2)
         print *,ddilog(-1d0/qs/us*(mta**2-mel**2)**2-2/qs*mta**2-1d0/qs*us)*born/pi*alpha*qel*qta*(2)
         print *,ddilog(-1/(-mta**2+us+betastata*mta**2+betastata*us)*mta**2-1/(-mta**2+us+betastata*mta**2+betastata*us)*us+1/(-mta**2+us+betasta
     & ta*mta**2+betastata*us)*betastata*mta**2+1/(-mta**2+us+betastata*mta**2+betastata*us)*betastata*us)*born/pi*alpha*qel*qta*(2)
         print *,ddilog(-1/(-mta**2+ts+betastata*mta**2+betastata*ts)*mta**2-1/(-mta**2+ts+betastata*mta**2+betastata*ts)*ts+1/(-mta**2+ts+betasta
     & ta*mta**2+betastata*ts)*betastata*mta**2+1/(-mta**2+ts+betastata*mta**2+betastata*ts)*betastata*ts)*born/pi*alpha*qel*qta*(-2)
      endif
      return
      end
