      subroutine toMomenta(Is,Ispr,Iph3,Icosth3,Icosth5,mp)
      implicit none!
      real*8 Is,Ispr,Iph3,Icosth3,Icosth5,mp(5)
      real*8 s,spr,ph3,costh3,costh5
      real*8 Momenta(5,5)
      real*8 p3r1(5),p4r1(5),p3r2(5),p4r2(5)
      real*8 cosph3,sinph3,sinth3,sinth5,ph5,cosph5,sinph5
      real*8 enf3,enf4,pf3,pf4
      real*8 sqs,sqspr
      real*8 betai,beta34,gamma34
      real*8 pg1(5),pg2(5),pg3(5),pg4(5),pg5(5)
      common/momenta/pg1,pg2,pg3,pg4,pg5
      s = Is
      spr = Ispr
      ph3 = Iph3
      ph5 = 0d0 !!!
      costh3 = Icosth3
      costh5 = Icosth5
      sinth3 = dsqrt((1d0-costh3)*(1d0+costh3))
      sinth5 = dsqrt((1d0-costh5)*(1d0+costh5))
      cosph3 = dcos(ph3)
      sinph3 = dsin(ph3)
      cosph5 = dcos(ph5)
      sinph5 = dsin(ph5)
      sqs = dsqrt(s)
      sqspr = dsqrt(spr)
      pf3 = dsqrt((spr-(mp(3)+mp(4))**2)*(spr-(mp(3)-mp(4))**2))/2d0/sqspr
      pf4 = pf3
      enf3 = (spr+mp(3)**2-mp(4)**2)/2d0/sqspr
      enf4 = (spr+mp(4)**2-mp(3)**2)/2d0/sqspr
      betai = dsqrt(1d0-4d0*mp(1)**2/s)
      beta34 = (s-spr)/(s+spr)
      gamma34 = 1d0/dsqrt(1d0-beta34**2)
c-----------------------------------------------------------------------
c--- p(1) = px, p(2) = py, p(3) = pz, p(4) = e, p(5) = m ---------------
c-----------------------------------------------------------------------
c... 4-momenta of particles in the rest reference frame of partons r1:
c... 3rd particle 4-momentum components:
      p3r1(1) = pf3*sinth3*cosph3
      p3r1(2) = pf3*sinth3*sinph3
      p3r1(3) = (pf3*costh3 - beta34*enf3)*gamma34
      p3r1(4) = (-beta34*pf3*costh3+enf3)*gamma34
c... 4th particle 4-momentum components:
      p4r1(1) = -pf4*sinth3*cosph3
      p4r1(2) = -pf4*sinth3*sinph3
      p4r1(3) = (-pf4*costh3 - beta34*enf4)*gamma34
      p4r1(4) = (beta34*pf4*costh3+enf4)*gamma34
c-----------------------------------------------------------------------
c... 4-momenta of particles in the rest reference frame of partons r2:
c... 3rd particle 4-momentum components:
      p3r2(1) = p3r1(2)*costh5 + p3r1(3)*sinth5
      p3r2(2) = -p3r1(1)
      p3r2(3) = -p3r1(2)*sinth5 + p3r1(3)*costh5
      p3r2(4) = p3r1(4)
c... 4th particle 4-momentum components:
      p4r2(1) = p4r1(2)*costh5 + p4r1(3)*sinth5
      p4r2(2) = -p4r1(1)
      p4r2(3) = -p4r1(2)*sinth5 + p4r1(3)*costh5
      p4r2(4) = p4r1(4)
c-----------------------------------------------------------------------
c... 4-momenta of particles in the laboratory reference frame
c... 1st particle (e^+) 4-momentum components:
      pg1(1) = 0d0
      pg1(2) = 0d0
      pg1(3) = betai*sqs/2d0
      pg1(4) = sqs/2d0
      pg1(5) = mp(1)
c... 2nd particle (e^-)  4-momentum components:
      pg2(1) = 0d0
      pg2(2) = 0d0
      pg2(3) = -betai*sqs/2d0
      pg2(4) = sqs/2d0
      pg2(5) = mp(2)
c... 3rd particle 4-momentum components:
      pg3(1) = p3r2(1)*cosph5-p3r2(2)*sinph5
      pg3(2) = p3r2(1)*sinph5+p3r2(2)*cosph5
      pg3(3) = p3r2(3)
      pg3(4) = p3r2(4)
      pg3(5) = mp(3)
c... 4th particle 4-momentum components:
      pg4(1) = p4r2(1)*cosph5-p4r2(2)*sinph5
      pg4(2) = p4r2(1)*sinph5+p4r2(2)*cosph5
      pg4(3) = p4r2(3)
      pg4(4) = p4r2(4)
      pg4(5) = mp(4)
c... 5th particle (photon) 4-momentum components:
      pg5(1) = (s-spr)/2d0/sqs*sinth5*cosph5
      pg5(2) = (s-spr)/2d0/sqs*sinth5*sinph5
      pg5(3) = (s-spr)/2d0/sqs*costh5
      pg5(4) = (s-spr)/2d0/sqs
      pg5(5) = mp(5)
      return
      end

      subroutine toMomenta1(Is,Ispr,Iph3,Icosth3,Icosth5,mp)
      implicit none!
      real*8 Is,Ispr,Iph3,Icosth3,Icosth5,mp(5)
      real*8 s,spr,ph3,costh3,costh5
      real*8 Momenta(5,5)
      real*8 p3r1(5),p4r1(5),p3r2(5),p4r2(5)
      real*8 cosph3,sinph3,sinth3,sinth5,ph5,cosph5,sinph5
      real*8 enf3,enf4,pf3,pf4
      real*8 sqs,sqspr
      real*8 betai,beta34,gamma34
      real*8 pg1(5),pg2(5),pg3(5),pg4(5),pg5(5)
      common/momenta/pg1,pg2,pg3,pg4,pg5
      s = Is
      spr = Ispr
      ph3 = Iph3
      ph5 = 0d0 !!!
      costh3 = (dexp(2d0*Icosth3)-1d0)/(dexp(2d0*Icosth3)+1d0)
      costh5 = (dexp(2d0*Icosth5)-1d0)/(dexp(2d0*Icosth5)+1d0)
      sinth3 = 2d0*dexp(Icosth3)/(dexp(2d0*Icosth3)+1d0)
      sinth5 = 2d0*dexp(Icosth5)/(dexp(2d0*Icosth5)+1d0)
      cosph3 = dcos(ph3)
      sinph3 = dsin(ph3)
      cosph5 = dcos(ph5)
      sinph5 = dsin(ph5)
      sqs = dsqrt(s)
      sqspr = dsqrt(spr)
      pf3 = dsqrt((spr-(mp(3)+mp(4))**2)*(spr-(mp(3)-mp(4))**2))/2d0/sqspr
      pf4 = pf3
      enf3 = (spr+mp(3)**2-mp(4)**2)/2d0/sqspr
      enf4 = (spr+mp(4)**2-mp(3)**2)/2d0/sqspr
      betai = dsqrt(1d0-4d0*mp(1)**2/s)
      beta34 = (s-spr)/(s+spr)
      gamma34 = 1d0/dsqrt(1d0-beta34**2)
c-----------------------------------------------------------------------
c--- p(1) = px, p(2) = py, p(3) = pz, p(4) = e, p(5) = m ---------------
c-----------------------------------------------------------------------
c... 4-momenta of particles in the rest reference frame of partons r1:
c... 3rd particle 4-momentum components:
      p3r1(1) = pf3*sinth3*cosph3
      p3r1(2) = pf3*sinth3*sinph3
      p3r1(3) = (pf3*costh3 - beta34*enf3)*gamma34
      p3r1(4) = (-beta34*pf3*costh3+enf3)*gamma34
c... 4th particle 4-momentum components:
      p4r1(1) = -pf4*sinth3*cosph3
      p4r1(2) = -pf4*sinth3*sinph3
      p4r1(3) = (-pf4*costh3 - beta34*enf4)*gamma34
      p4r1(4) = (beta34*pf4*costh3+enf4)*gamma34
c-----------------------------------------------------------------------
c... 4-momenta of particles in the rest reference frame of partons r2:
c... 3rd particle 4-momentum components:
      p3r2(1) = p3r1(2)*costh5 + p3r1(3)*sinth5
      p3r2(2) = -p3r1(1)
      p3r2(3) = -p3r1(2)*sinth5 + p3r1(3)*costh5
      p3r2(4) = p3r1(4)
c... 4th particle 4-momentum components:
      p4r2(1) = p4r1(2)*costh5 + p4r1(3)*sinth5
      p4r2(2) = -p4r1(1)
      p4r2(3) = -p4r1(2)*sinth5 + p4r1(3)*costh5
      p4r2(4) = p4r1(4)
c-----------------------------------------------------------------------
c... 4-momenta of particles in the laboratory reference frame
c... 1st particle (e^+) 4-momentum components:
      pg1(1) = 0d0
      pg1(2) = 0d0
      pg1(3) = betai*sqs/2d0
      pg1(4) = sqs/2d0
      pg1(5) = mp(1)
c... 2nd particle (e^-)  4-momentum components:
      pg2(1) = 0d0
      pg2(2) = 0d0
      pg2(3) = -betai*sqs/2d0
      pg2(4) = sqs/2d0
      pg2(5) = mp(2)
c... 3rd particle 4-momentum components:
      pg3(1) = p3r2(1)*cosph5-p3r2(2)*sinph5
      pg3(2) = p3r2(1)*sinph5+p3r2(2)*cosph5
      pg3(3) = p3r2(3)
      pg3(4) = p3r2(4)
      pg3(5) = mp(3)
c... 4th particle 4-momentum components:
      pg4(1) = p4r2(1)*cosph5-p4r2(2)*sinph5
      pg4(2) = p4r2(1)*sinph5+p4r2(2)*cosph5
      pg4(3) = p4r2(3)
      pg4(4) = p4r2(4)
      pg4(5) = mp(4)
c... 5th particle (photon) 4-momentum components:
      pg5(1) = (s-spr)/2d0/sqs*sinth5*cosph5
      pg5(2) = (s-spr)/2d0/sqs*sinth5*sinph5
      pg5(3) = (s-spr)/2d0/sqs*costh5
      pg5(4) = (s-spr)/2d0/sqs
      pg5(5) = mp(5)
      return
      end
